petsc-3.12.4 2020-02-04
Report Typos and Errors

# DMCreateDomainDecomposition

Returns lists of IS objects defining a decomposition of a problem into subproblems corresponding to restrictions to pairs nested subdomains: each IS contains the global indices of the dofs of the corresponding subdomains. The inner subdomains conceptually define a nonoverlapping covering, while outer subdomains can overlap. The optional list of DMs define the DM for each subproblem.

### Synopsis

    #include "petscdm.h"
    #include "petscdmlabel.h"
    #include "petscds.h"
    PetscErrorCode DMCreateDomainDecomposition(DM dm, PetscInt *len, char ***namelist, IS **innerislist, IS **outerislist, DM **dmlist)

Not collective

### Input Parameter

dm -the DM object

### Output Parameters

| len | - The number of subproblems in the domain decomposition (or NULL if not requested)
| namelist | - The name for each subdomain (or NULL if not requested)
| innerislist | - The global indices for each inner subdomain (or NULL, if not requested)
| outerislist | - The global indices for each outer subdomain (or NULL, if not requested)
| dmlist | - The DMs for each subdomain subproblem (or NULL, if not requested; if NULL is returned, no DMs are defined)

### Notes

The user is responsible for freeing all requested arrays. In particular, every entry of names should be freed with PetscFree(), every entry of is should be destroyed with ISDestroy(), every entry of dm should be destroyed with DMDestroy(), and all of the arrays should be freed with PetscFree().

### See Also

DMDestroy(), DMView(), DMCreateInterpolation(), DMCreateColoring(), DMCreateMatrix(), DMCreateDomainDecompositionDM(), DMCreateFieldDecomposition()

### Level

intermediate

### Location

src/dm/interface/dm.c

### Implementations

DMCreateDomainDecomposition_DA in src/dm/impls/da/dadd.c
Index of all DM routines
Table of Contents for all manual pages
Index of all manual pages